Subject: TYPO3 Neos API Definition
Description

Defining the TYPO3 Neos API
    -  Target Audience: developers and integrators who plan to customize TYPO3 Neos
    -  Responsible: Sebastian Kurfürst <sebastian (at) typo3 (dot) org>
    -  Implemented by: Sebastian Kurfürst, Robert Lemke
    -  Amount: 15 work days
    -  Version: must have for 1.0

Motivation
Neos is still under massive development, and will likely stay that way. However, we want to make sure that it is usable for
implementors, such that they know which parts we consider as stable.

In practice, this means that the parts of the system which we consider as stable are marked as API. This includes PHP classes,
configuration settings, and TypoScript objects.

Goal
Before we can release version 1.0 of Neos, we need to initially check the various components for stability and document that
accordingly. Additionally, if we find naming annoyances in parts which are public API we'll rename them as needed.

Deliverables
    -  must have, complete: stable configuration settings (especially node type definitions) are explained and documented in the Neos
Integrator Guide
    -  must have, complete: stable TypoScript objects are documented in the Neos Integrator Guide
    -  must have, as much as possible: stable PHP methods in Neos are marked with @api
    -  can have: upgrade Ember to recent version to make extending the property inspector possible

Related issues:
related to Base Distribution - Story # 44970: Define Neos 1.0 API New 2013-01-30
related to Base Distribution - Story # 44982: Refactor Node Type Definition a... Resolved 2013-01-30
related to Base Distribution - Task # 45317: Refine / Rename node type hierarchy Resolved 2013-02-09
related to TYPO3.Neos - Task # 47177: Update Ember to 1.0 Resolved 2013-04-13

History
#1 - 2013-01-31 11:03 - Sebastian Kurfuerst
- Subject changed from [WP] TYPO3 Neos API Definition to TYPO3 Neos API Definition

#2 - 2013-02-07 07:32 - Sebastian Kurfuerst

    -  TODO: discuss whether to leave out the $ at the beginning of Eel expressions (as it is not needed really)

#3 - 2013-02-16 14:59 - Sebastian Kurfuerst
- Status changed from New to Accepted
#4 - 2013-02-16 15:17 - Sebastian Kurfuerst
- File typo3neos-distribution-base-44971.pdf added
- Start date deleted (2013-01-30)
- Estimated time set to 90.00

Has been discussed with Jan-Hendrik from the EAB on 12.02.2013; and has been accepted on 15.02.2013 by the EAB.
(The attached PDF is a snapshot of this work package at the time of acceptance.)

So, (myself) and Robert, you can schedule this work package in your day-to-day calendar and implement it then -- can't wait to see it in Neos 1.0 :-)

Another side-note: I shall not forget to add comments to this work package and update "% done" while I am working on this package.

Greets (to myself ;) ), Sebastian

PS: Still need to discuss start and due dates with Robert

#5 - 2013-04-03 15:12 - Sebastian Kurfuerst
- % Done changed from 0 to 10

The following is our ToDo list:

    -  DONE (Robert) go through TYPO3CR PHP APIhttps://review.typo3.org/#/c/19511/
        -  Created / Last Modified for Nodes?
        -  Node->isVisible() should take isAccessible() into accountx

    -  go through Neos PHP API (Content Context?)
    -  Dependency Analysis between TYPO3CR and Neos (check that TYPO3CR does not depend on Neos)
    -  Node Type Definitions should be documented in Neos Integrator Guide
    -  DONE (Sebastian) Node Type Definitions should be covered by Schema
        -  https://review.typo3.org/#/q/topic:44990,n,z
    -  TODO Schema should be tested in CI Server (+1 für Configuration)
    -  !!! TODO (Robert) refine Node Type Names http://forge.typo3.org/issues/45317
        -  check / fix node type migrations
    -  JS APIs:
        -  !!! TODO (Sebastian) Ember Update?
        -  Content Module Inspector Editors
        -  add ability to add new JS files for Content Module
        -  “Selector Box Provider?” by Marc Neuhaus
    -  BE Modules
        -  document / validate YAML Configuration
        -  check PHP
    -  !!! TODO (Robert) TypoScript
        -  Using pre-existing TS objects (config parameters, ...)
        -  Conventions (where is it located in the file system, ...)
        -  [Creating own TS objects]
    -  Commands / Command Line
    -  Non-HTML output formats (f.e. RSS)
    -  API to figure out if we are in BE or FE
        -  perhaps in Plugin TS object?
        -  perhaps a special “if”
    -  [Bonus: response unification]

#6 - 2013-04-03 15:14 - Sebastian Kurfuerst
- Due date set to 2013-04-30

#7 - 2013-05-16 09:53 - Sebastian Kurfuerst
- Due date changed from 2013-04-30 to 2013-05-30
- % Done changed from 10 to 50

updated due date to more realistic estimate, current status is:

    -  config settings are stable and documented
    -  ember Update is done
    -  @API methods exist in TYPO3CR
    -  TODO TypoScript objects are just partially documented so far
    -  TODO Karsten:  start with Node Type renaming (#45317)

We will meet on June 24th to June 26th (online) to work on this, and expect to have it mostly finished by the end of that time.

#8 - 2013-05-16 10:40 - Sebastian Kurfuerst
- Due date changed from 2013-05-30 to 2013-06-30

Files
typo3neos-distribution-base-44971.pdf 3.3 kB 2013-02-16 Sebastian Kurfuerst
